function dDldadtheta = computedDldadtheta (X1, X2, Y1, Y2, W, theta, i)
	m1 = mean(Y1, 2);
	m2 = mean(Y2, 2);

	B = (m2 - m1) * (m2 - m1)';

	pstar = computepstar(X1, X2, Y1, Y2, W, theta);
	% Precompute stuff
	dbdtheta = computedbbdtheta(mean(X1, 2), mean(X2, 2), theta, i);
	dWdtheta = computedWdtheta(X1, X2, Y1, Y2, theta, i);

	Num = pstar' * B * pstar;  % numerator
	dpstardtheta = computedpstardtheta(X1, X2, Y1, Y2, W, theta, dbdtheta, dWdtheta, i);
	dNumdtheta = dpstardtheta' * (B * pstar) + ...
	           pstar' * (computedBdtheta(X1, X2, Y1, Y2, theta, dbdtheta, i) * pstar + B * dpstardtheta);
	Denom = pstar' * W * pstar;  % denominator
	dDenomdtheta = dpstardtheta' * (W * pstar) + ...
	           pstar' * (dWdtheta * pstar + W * dpstardtheta);

	dDldadtheta = -1 * Num * Denom^-2 * dDenomdtheta + dNumdtheta ./ Denom;
end
