function [ R, model ] = reconstruct (X, Y, ridgeTerm)
	N = size(X, 2);
	P = size(X, 1);

	Yaugmented = [ ones(1, size(Y, 2)); Y ];
	Yaugmented = Yaugmented';
	ridgeMtx = ridgeTerm * eye(size(Yaugmented, 2));
	ridgeMtx(1,1) = 0;  % No ridge on bias term!

	model = (Yaugmented'*Yaugmented + ridgeMtx)\Yaugmented'*X';
	model = model';
	R = model * [ ones(1, N); Y ];
end
