function show (X1, X2, Y1, Y2, theta, figNum, delta)
	X1 = X1(:, 1:min(10, size(X1,2)));
	X2 = X2(:, 1:min(10, size(X2,2)));
	Y1 = Y1(:, 1:min(10, size(Y1,2)));
	Y2 = Y2(:, 1:min(10, size(Y2,2)));
	X = [ X1, X2 ];
	Y = [ Y1, Y2 ];
	n = sqrt(size(Y1, 1));

	figure(figNum);

	subplot(4,1,1);
	for i = 1:size(Y, 2)
		patches(:,:,i) = reshape(Y(:,i), [ n n ]);
	end
	imshow(make_montage(patches, 1, 20, 4), []);

	subplot(4,1,2);
	n = sqrt(size(X1, 1));
	for i = 1:size(X, 2)
		patches(:,:,i) = reshape(X(:,i), [ n n ]);
	end
	imshow(make_montage(patches, 1, 20, 4), []);

	subplot(4,1,3);
	imshow(imresize(reshape(theta, [n n]), 4, 'nearest'), []);

	subplot(4,1,4);
	R = reconstruct(X, Y, delta);
	for i = 1:size(R, 2)
		patches(:,:,i) = reshape(R(:,i), [ n n ]);
	end
	imshow(make_montage(patches, 1, 20, 4), []);
end
